variables:
  REGISTRY_IMAGE: $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA

stages:
  - build
  - test
  - package
  - deploy

build:
  image: gradle:alpine
  stage: build
  script: gradle --build-cache bootjar
  artifacts:
    paths:
      - build
      - .gradle

test:
  image: gradle:alpine
  stage: test
  script: gradle test
  artifacts:
    paths:
      - build
      - .gradle

docker-build:
  image: docker:latest
  services:
    - docker:dind
  stage: package
  script:
    - docker build -t $REGISTRY_IMAGE .
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
    - docker push $REGISTRY_IMAGE

k8s-deploy-starter:
  image: google/cloud-sdk
  stage: deploy
  script:
    - echo "$GOOGLE_KEY" > key.json
    - gcloud auth activate-service-account --key-file key.json
    - gcloud config set compute/zone $CLUSTER_ZONE
    - gcloud config set project $GCP_PROJECT_NAME
    - gcloud container clusters get-credentials $CLUSTER_NAME --zone $CLUSTER_ZONE --project dev-bootcamp-236808
    - kubectl create namespace starter 2>/dev/null || echo "namespace starter already exist"
    - kubectl config set-context --current --namespace=starter
    - kubectl delete secret yashaswini-cart-api-registry 2>/dev/null || echo "secret does not exist"
    - kubectl create secret docker-registry yashaswini-cart-api-registry --docker-server=https://registry.gitlab.com --docker-username=$REGISTRY_TOKEN --docker-password=$REGISTRY_PASSWD
    - kubectl apply -f deployment.yml
    - kubectl set image deployment/yashaswini-cart-api yashaswini-cart-api=$REGISTRY_IMAGE